#!/usr/bin/env node

var fs = require('fs');
var path = require('path');
var deploy = require('scp2');
var yaml = require('js-yaml');

console.time('Deployment');

try {

   var dir = process.cwd();
   var file = fs.readFileSync(path.join(dir, 'deploy.yaml'));
   var config = yaml.safeLoad(file);
   var remote = config.user + ':' + config.password + '@' + config.host + ':' + config.path;

   /*
    * Note: the scp callback is called twice upon an error
    * which seems to be a bug in the scp2 module
    * Quick and dirty workaround: set a flag
    */

   var flag = false;
   deploy.scp(dir, remote, function(err) {
      if (!flag) {
         flag = true;
         if (err) {
            console.timeEnd('Deployment');
            console.log('Error: ' + err.message);
         } else {
            console.timeEnd('Deployment');
         }
      }
   });

} catch (err) {
   console.timeEnd('Deployment');
   console.log('Error: ' + err.message);
}
